=== debian/changelog ===
ros-humble-rclcpp (16.0.5-2jammy) jammy; urgency=high

  * warning: comparison of integer expressions of different signedness (#2219 <https://github.com/ros2/rclcpp/issues/2219>) (#2223 <https://github.com/ros2/rclcpp/issues/2223>)
  * Trigger the intraprocess guard condition with data (#2164 <https://github.com/ros2/rclcpp/issues/2164>) (#2167 <https://github.com/ros2/rclcpp/issues/2167>)
  * Implement validity checks for rclcpp::Clock (#2040 <https://github.com/ros2/rclcpp/issues/2040>) (#2210 <https://github.com/ros2/rclcpp/issues/2210>)
  * Contributors: Tomoya Fujita, mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 17 Jul 2023 00:00:00 -0000

ros-humble-rclcpp (16.0.4-2jammy) jammy; urgency=high

  * use allocator via init_options argument. (#2129 <https://github.com/ros2/rclcpp/issues/2129>) (#2131 <https://github.com/ros2/rclcpp/issues/2131>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 25 Apr 2023 00:00:00 -0000

ros-humble-rclcpp (16.0.3-2jammy) jammy; urgency=high

  * Fix SharedFuture from async_send_request never becomes valid (#2044 <https://github.com/ros2/rclcpp/issues/2044>) (#2076 <https://github.com/ros2/rclcpp/issues/2076>)
  * do not throw exception if trying to dequeue an empty intra-process buffer (#2061 <https://github.com/ros2/rclcpp/issues/2061>) (#2070 <https://github.com/ros2/rclcpp/issues/2070>)
  * fix nullptr dereference in prune_requests_older_than (#2008 <https://github.com/ros2/rclcpp/issues/2008>) (#2065 <https://github.com/ros2/rclcpp/issues/2065>)
  * Fix bug that a callback not reached (#1640 <https://github.com/ros2/rclcpp/issues/1640>) (#2033 <https://github.com/ros2/rclcpp/issues/2033>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 10 Jan 2023 00:00:00 -0000

ros-humble-rclcpp (16.0.2-2jammy) jammy; urgency=high

  * fix mismatched issue if using zero_allocate (#1995 <https://github.com/ros2/rclcpp/issues/1995>) (#2026 <https://github.com/ros2/rclcpp/issues/2026>)
  * use regex for wildcard matching (backport #1839 <https://github.com/ros2/rclcpp/issues/1839>) (#1986 <https://github.com/ros2/rclcpp/issues/1986>)
  * Drop wrong template specialization (#1926 <https://github.com/ros2/rclcpp/issues/1926>) (#1937 <https://github.com/ros2/rclcpp/issues/1937>)
  * Add statistics for handle_loaned_message (#1927 <https://github.com/ros2/rclcpp/issues/1927>) (#1932 <https://github.com/ros2/rclcpp/issues/1932>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 07 Nov 2022 00:00:00 -0000

ros-humble-rclcpp (16.0.1-2jammy) jammy; urgency=high

  * remove DEFINE_CONTENT_FILTER cmake option (#1914 <https://github.com/ros2/rclcpp/issues/1914>)
  * Contributors: Chen Lihui

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 13 Apr 2022 00:00:00 -0000

ros-humble-rclcpp (16.0.0-2jammy) jammy; urgency=high

  * remove things that were deprecated during galactic (#1913 <https://github.com/ros2/rclcpp/issues/1913>)
  * Contributors: William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-humble-rclcpp (15.4.0-2jammy) jammy; urgency=high

  * add take_data_by_entity_id API to waitable (#1892 <https://github.com/ros2/rclcpp/issues/1892>)
  * add content-filtered-topic interfaces (#1561 <https://github.com/ros2/rclcpp/issues/1561>)
  * Contributors: Alberto Soragna, Chen Lihui

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 05 Apr 2022 00:00:00 -0000

ros-humble-rclcpp (15.3.0-2jammy) jammy; urgency=high

  * [NodeParameters] Set name in param info pre-check (#1908 <https://github.com/ros2/rclcpp/issues/1908>)
  * Add test-dep ament_cmake_google_benchmark (#1904 <https://github.com/ros2/rclcpp/issues/1904>)
  * Add publish by loaned message in GenericPublisher (#1856 <https://github.com/ros2/rclcpp/issues/1856>)
  * Contributors: Abrar Rahman Protyasha, Barry Xu, Gaël Écorchard

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 30 Mar 2022 00:00:00 -0000

ros-humble-rclcpp (15.2.0-2jammy) jammy; urgency=high

  * Add missing ament dependency on rcl_interfaces (#1903 <https://github.com/ros2/rclcpp/issues/1903>)
  * Update data callback tests to account for all published samples (#1900 <https://github.com/ros2/rclcpp/issues/1900>)
  * Increase timeout for acknowledgments to account for slower Connext settings (#1901 <https://github.com/ros2/rclcpp/issues/1901>)
  * clang-tidy: explicit constructors (#1782 <https://github.com/ros2/rclcpp/issues/1782>)
  * Add client/service QoS getters (#1784 <https://github.com/ros2/rclcpp/issues/1784>)
  * Fix a bunch more rosdoc2 issues in rclcpp. (#1897 <https://github.com/ros2/rclcpp/issues/1897>)
  * time_until_trigger returns max time if timer is cancelled (#1893 <https://github.com/ros2/rclcpp/issues/1893>)
  * Micro-optimizations in rclcpp (#1896 <https://github.com/ros2/rclcpp/issues/1896>)
  * Contributors: Andrea Sorbini, Chris Lalancette, Mauro Passerino, Scott K Logan, William Woodall

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 24 Mar 2022 00:00:00 -0000

ros-humble-rclcpp (15.1.0-2jammy) jammy; urgency=high

  * spin_all with a zero timeout. (#1878 <https://github.com/ros2/rclcpp/issues/1878>)
  * Add RMW listener APIs (#1579 <https://github.com/ros2/rclcpp/issues/1579>)
  * Remove fastrtps customization on tests (#1887 <https://github.com/ros2/rclcpp/issues/1887>)
  * Install headers to include/${PROJECT_NAME} (#1888 <https://github.com/ros2/rclcpp/issues/1888>)
  * Use ament_generate_version_header (#1886 <https://github.com/ros2/rclcpp/issues/1886>)
  * use universal reference to support rvalue. (#1883 <https://github.com/ros2/rclcpp/issues/1883>)
  * fix one subscription can wait_for_message twice (#1870 <https://github.com/ros2/rclcpp/issues/1870>)
  * Add return value version of get_parameter_or (#1813 <https://github.com/ros2/rclcpp/issues/1813>)

